import { Codec, decodeType, runtimeType } from "./Codec";
import { LocalStorageOptions, StorageDef, RuntimeValues } from "localvalue-ts";
import * as LV from "./LocalValue";
declare type ValidCodec = Codec<any, string, any>;
declare type ValidLocalValue<A> = LV.Absent | LV.Valid<A>;
interface UseLocalItemOptions<C extends ValidCodec> {
    useMemorySore?: boolean;
    defaultValue?: runtimeType<C>;
}
export declare type LocalValueHook<C extends ValidCodec> = () => [
    item: decodeType<C>,
    setItem: (i: ValidLocalValue<runtimeType<C>>) => void
];
export declare const makeUseLocalItem: <C extends ValidCodec>(key: string, codec: C, options?: UseLocalItemOptions<C> | undefined) => LocalValueHook<C>;
declare type StorageHooks<S> = S extends StorageDef<infer K> ? {
    [k in K as `use${Capitalize<k>}`]: LocalValueHook<S[K]>;
} : never;
export declare const makeStorageHooks: <S extends StorageDef<any>>(storage: S, o?: LocalStorageOptions<RuntimeValues<S>> | undefined) => StorageHooks<S>;
export {};
