"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.makeStorageHooks = exports.makeUseLocalItem = void 0;
var React = __importStar(require("react"));
var R = __importStar(require("fp-ts/Record"));
var O = __importStar(require("fp-ts/Option"));
var function_1 = require("fp-ts/function");
var localvalue_ts_1 = require("localvalue-ts");
var localStorageProxy_1 = require("localvalue-ts/localStorageProxy");
var LV = __importStar(require("./LocalValue"));
var makeUseLocalItem = function (key, codec, options) {
    return (function () {
        var _a = React.useState(localvalue_ts_1.getLocalValue(key, codec, options)), item = _a[0], setItem = _a[1];
        var setItemMemo = React.useMemo(function () {
            return function (i) {
                return function_1.pipe(i, LV.fold2(function () {
                    localvalue_ts_1.removeLocalValue(key, options);
                    setItem(localvalue_ts_1.getLocalValue(key, codec, options));
                }, function (newValue) {
                    localvalue_ts_1.setLocalValue(key, codec, newValue, options);
                    setItem(localvalue_ts_1.getLocalValue(key, codec, options));
                }));
            };
        }, [item]);
        var onLocalStorageChange = function (event) {
            if (localStorageProxy_1.isLocalStorageEvent(event)) {
                if (event.detail.key === key) {
                    setItem(localvalue_ts_1.getLocalValue(key, codec, options));
                }
            }
            else {
                if (event.key === key) {
                    setItem(localvalue_ts_1.getLocalValue(key, codec, options));
                }
            }
        };
        React.useEffect(function () {
            var listener = function (e) {
                onLocalStorageChange(e);
            };
            window.addEventListener(localStorageProxy_1.storeChangedCustomEvent, listener);
            // The storage event only works in the context of other documents (eg. other browser tabs)
            window.addEventListener("storage", listener);
            return function () {
                window.removeEventListener(localStorageProxy_1.storeChangedCustomEvent, listener);
                window.removeEventListener("storage", listener);
            };
        }, [key]);
        return [item, setItemMemo];
    });
};
exports.makeUseLocalItem = makeUseLocalItem;
var storageOptionsToValueOptions = function (k, so) { return ({
    useMemorySore: so === null || so === void 0 ? void 0 : so.useMemorySore,
    defaultValue: (so === null || so === void 0 ? void 0 : so.defaultValues) === undefined
        ? undefined
        : function_1.pipe(R.lookup(k, so.defaultValues), O.getOrElse(function () { return undefined; })),
}); };
var capitalize = function (s) {
    return s.charAt(0).toUpperCase() + s.slice(1);
};
var makeStorageHooks = function (storage, o) {
    return function_1.pipe(storage, R.reduceWithIndex({}, function (k, acc, c) {
        var _a;
        return (__assign(__assign({}, acc), (_a = {}, _a["use" + capitalize(k)] = exports.makeUseLocalItem(k, c, storageOptionsToValueOptions(k, o)), _a)));
    }));
};
exports.makeStorageHooks = makeStorageHooks;
